<div class="container-fluid">
  <form [formGroup]="form"
        (keydown.enter)="$event.preventDefault()"
        (ngSubmit)="submit(form.value)"
        class="needs-validation" novalidate>
    <fieldset>
      <legend>فاتورة بيع جديدة</legend>

      <!-- not required -->
      <!--<div class="card mb-4">
        <div class="card-body">
          <div class="row g-4">
            <div class="col-md-3">
              <label for="Date" class="form-label">تاريح إصدار الفاتورة <sub class="text-danger fs-6">*</sub></label>
              <input type="text"
                     class="form-control form-control-sm"
                     bsDatepicker
                     id="Date"
                     formControlName="date"
                     [bsConfig]="{ adaptivePosition: true }">
              <div class="invalid-feedback">
                برجاء ادخال التاريح
              </div>
            </div>
            <div class="col-md-3">
              <label for="Branch" class="form-label">الفرع <sub class="text-danger fs-6">*</sub></label>
              <ngx-select
                [items]="branches"
                id="Branch"
                [autoClearSearch]="true"
                size="small"
                optionValueField="id"
                optionTextField="name"
                formControlName="branch_id"
                [allowClear]="true"
              ></ngx-select>
              <div class="invalid-feedback">
                برجاء اختيار الفرع
              </div>
            </div>
            <div class="col-md-3">
              <label for="Repository" class="form-label">المستودع <sub class="text-danger fs-6">*</sub></label>
              <ngx-select
                [items]="repositories"
                id="Repository"
                [autoClearSearch]="true"
                size="small"
                optionValueField="id"
                optionTextField="name"
                formControlName="repository_id"
                [allowClear]="true"
              ></ngx-select>
              <div class="invalid-feedback">
                برجاء اختيار المستودع
              </div>
            </div>
            <div class="col-md-3">
              <label for="Repository" class="form-label"> رقم الفاتورة <sub class="text-danger fs-6">*</sub></label>
              <div class="form-control form-control-sm disabled">574</div>
            </div>
            <div class="col-md-3">
              <label for="Repository" class="form-label">العملاء </label>
              <div class="d-flex align-items-center">
                <div class="input-group flex-nowrap">
                  <ngx-select [allowClear]="true"
                              [items]="customers"
                              optionValueField="id"
                              size="small"
                              formControlName="customer_id"
                              optionTextField="name"
                              class="w-100">
                  </ngx-select>
                  <button class="btn btn-sm btn-primary input-group-append" type="button" data-toggle="modal"
                          data-target="#newHotelPop">
                    <i class="icon-eye"></i>
                  </button>
                </div>
                <button class="btn btn-sm btn-primary ms-2" type="button" data-toggle="modal"
                        data-target="#newHotelPop">
                  <i class="icon-plus"></i>
                </button>
              </div>
            </div>
            <div class="col-md-3">
              <label for="AffiliateItems" class="form-label">البنود التابعة</label>
              <ngx-select
                [items]="affiliateItems"
                id="AffiliateItems"
                [autoClearSearch]="true"
                size="small"
                optionValueField="id"
                optionTextField="name"
                formControlName="affiliate_item_id"
                [allowClear]="true"
              ></ngx-select>
            </div>
            <div class="col-md-3">
              <label for="Currency" class="form-label">عملة <sub class="text-danger fs-6">*</sub></label>
              <ngx-select
                [items]="currencies"
                id="Currency"
                [autoClearSearch]="true"
                size="small"
                optionValueField="id"
                optionTextField="symbol"
                formControlName="currency_id"
                [allowClear]="true"
              ></ngx-select>
            </div>
            <div class="col-md-3">
              <label for="Order" class="form-label">بناء على <sub class="text-danger fs-6">*</sub></label>
              <ngx-select
                [items]="orders"
                id="Order"
                [autoClearSearch]="true"
                size="small"
                optionValueField="id"
                optionTextField="name"
                formControlName="order_id"
                [allowClear]="true"
              ></ngx-select>
            </div>
            <div class="col-md-3">
              <label for="ReferenceCode" class="form-label">الكود المرجعي <sub class="text-danger fs-6">*</sub></label>
              <input type="number"
                     class="form-control form-control-sm"
                     id="ReferenceCode"
                     formControlName="reference_code">
            </div>
            <div class="col-md-3">
              <label for="InvoiceType" class="form-label">نوع الفاتورة <sub class="text-danger fs-6">*</sub></label>
              <ngx-select
                [items]="invoiceTypes"
                id="InvoiceType"
                [autoClearSearch]="true"
                size="small"
                optionValueField="id"
                optionTextField="name"
                formControlName="invoice_type_id"
                [allowClear]="true"
              ></ngx-select>
            </div>
            <div class="col-md-3 d-flex align-items-end">
              <div class="form-check">
                <input class="form-check-input" formControlName="automatic_exchange" type="checkbox"
                       id="AutomaticExchange">
                <label class="form-check-label" for="AutomaticExchange">
                  صرف آلي
                </label>
              </div>
            </div>
          </div>
        </div>
      </div>-->

      <div class="card">
        <div class="card-body">
          <table class="table table-bordered table-hover table-sm table-striped">
            <thead>
            <tr>
              <th scope="col">تفاصيل السلع والخدمات</th>
              <th scope="col">الوحدة</th>
              <th scope="col">الكمية</th>
              <th scope="col"> سعر الوحدة<sub class="text-danger fs-6">*</sub></th>
              <th scope="col">خصومات</th>
              <th scope="col">المبلغ الخاضع للضريبة</th>
              <th scope="col">نسبة الضريبة</th>
              <th scope="col">مبلغ الضريبة</th>
              <th scope="col">الإجمالي (شامل ضريبة القيمة المضافة)</th>
              <th scope="col">خيارات</th>
            </tr>
            </thead>
            <!-- services -->
            <ng-container *ngFor="let item of fieldArraysForm ;let i = index">
              <tbody formArrayName="services">
              <tr [formGroupName]="i">
                <td (click)="goodsServicesHidden('show', i)"> <!--تفاصيل السلع والخدمات-->
                  <ngx-select
                    [items]="services"
                    [autoClearSearch]="true"
                    size="small"
                    optionValueField="id"
                    (close)="goodsServicesHidden('hide', i)"
                    optionTextField="name"
                    formControlName="goods_service_id"
                    [allowClear]="true"
                    (ngModelChange)="getGoodsAndServices($event, i)"
                    [tabIndex]="1"
                    *ngIf="!form.get('services')?.value[i]?.goods_service_id || goodsServicesToggle[i]"
                    #goods_services
                  ></ngx-select>
                  <span *ngIf="!goodsServicesToggle[i]" class="text-truncate">{{current_val_Goods_services[i]}}</span>
                </td>
                <td> <!--الوحدة-->
                  <ngx-select
                    [items]="units[i]"
                    [autoClearSearch]="true"
                    size="small"
                    (remove)="clearUnits($event, i)"
                    [ngModel]="form.get('services')?.value[i]?.unit_id"
                    optionValueField="id"
                    optionTextField="name"
                    formControlName="unit_id"
                    [allowClear]="true"
                  ></ngx-select>
                </td>
                <td> <!--الكمية-->
                  <div class="input-group input-group-sm">
                    <button type="button" class="input-group-text" tooltip="tooltip">
                      <i class="icon-attention-alt"></i>
                    </button>
                    <input type="number"
                           [tabIndex]="2"
                           (keyup.enter)="addNewRow()" (keyup)="calculate()" formControlName="quantity"
                           #quantities
                           class="form-control">
                  </div>
                </td>
                <td> <!--سعر الوحدة-->
                  <div class="input-group input-group-sm position-relative">
                    <button type="button" class="input-group-text" tooltip="tooltip">
                      <i class="icon-attention-alt"></i>
                    </button>
                    <input type="number" formControlName="unit_price"
                           (keyup)="calculate()" class="form-control"
                           [tabIndex]="3"
                           [ngClass]="{'is-invalid': isInValidFormArray.at(i).get('unit_price')?.invalid}">
                    <div class="invalid-tooltip">
                      برجاء ادخال سعر الوحدة
                    </div>
                  </div>
                </td>
                <td> <!--خصومات-->
                  <div class="d-flex align-items-center">
                    <div class="input-group input-group-sm">
                      <ngx-select
                        [items]="discountType"
                        size="small"
                        optionValueField="id"
                        optionTextField="name"
                        formControlName="discount_type_id"
                        (select)="calculate()"
                      ></ngx-select>
                      <input type="number"
                             [tabIndex]="4"
                             (keyup)="calculate()" formControlName="discount" class="form-control">
                    </div>
                    <span class="text-nowrap ms-2">
                      {{form.get('services')?.value[i]?.discount_percentage}}
                      {{form.get('services')?.value[i]?.discount_type_id === 1 ? "%" : ""}}
                    </span>
                  </div>
                </td>
                <td> <!--المبلغ الخاضع للضريبة-->
                  <span>{{form.get('services')?.value[i]?.taxable_amount}}</span>
                </td>
                <td> <!--نسبة الضريبة-->
                  <span>{{form.get('services')?.value[i]?.tax_rate}}</span>
                </td>
                <td> <!--مبلغ الضريبة-->
                  <span>{{form.get('services')?.value[i]?.tax_amount}}</span>
                </td>
                <td> <!--الإجمالي (شامل ضريبة القيمة المضافة)-->
                  <span>{{form.get('services')?.value[i]?.gross_incl_vat}}</span>
                </td>
                <th> <!--خيارات-->
                  <button (click)="removeFormArray(i)" tooltip="حذف"
                          type="button" class="btn btn-sm p-1 btn-danger">
                    <i class="icon-trash"></i></button>
                </th>
              </tr>
              </tbody>
            </ng-container>
          </table>
        </div>
      </div>
      <div class="card-footer d-flex align-items-center justify-content-between">
        <button type="submit" class="btn btn-primary m-4">Submit</button>
        <h5>الاجمالي : {{total}}</h5>
      </div>
    </fieldset>
  </form>
</div>
